package fireworx;

import java.sql.*;
import java.io.*;

public class DaysEventsQueryBean extends QueryBean {
  
  private String houseCode;
  private String eventMonth;
  private String eventDay;
  private String eventYear;
  
  public DaysEventsQueryBean() {
  }
  
  public boolean queryDatabase() {
  	
  	String orderBy = null;
  	
  	String datSelectedDate = eventMonth + " " + eventDay + ", " + eventYear;
  	  	  	
   	String sql = "SELECT x.EventID as ID ,x.HouseCode, x.Device as Unit, x.Action, z.Description, x.Time, x.Category " +
        "FROM Events x, Devices z " +
        "WHERE DateValue('" + datSelectedDate + "') >= x.StartDate and DateValue('" + datSelectedDate + "') <= x.EndDate " +
            "and ((WeekDay(DateValue('" + datSelectedDate + "')) = 1 and x.Su = ' x ') " +
                "or (WeekDay(DateValue('" + datSelectedDate + "')) = 2 and x.Mo = ' x ') or (WeekDay(DateValue('" + datSelectedDate + "')) = 3 and x.Tu = ' x ') " +
                "or (WeekDay(DateValue('" + datSelectedDate + "')) = 4 and x.We = ' x ') or (WeekDay(DateValue('" + datSelectedDate + "')) = 5 and x.Th = ' x ') " +
                "or (WeekDay(DateValue('" + datSelectedDate + "')) = 6 and x.Fr = ' x ') or (WeekDay(DateValue('" + datSelectedDate + "')) = 7 and x.Sa = ' x ') " +
            ") " +
            "and z.Device = (x.HouseCode + x.Device) " +
            "and (x.Category = ' ' or x.Category = ANY(SELECT Category FROM Categories WHERE RunEvents = 'Yes'))";
            
//    if (houseCode != null && !houseCode.equals("*"))
//    	sql = sql + " where Device like '" + houseCode + "%'";
  
    if (sortBy != null) {
     	if (sortBy.equals("ID"))
     			orderBy = " order by EventID " + sortOrder;
     	else if (sortBy.equals("HouseCode"))
     			orderBy = " order by x.HouseCode " + sortOrder + ", x.Device " + sortOrder;
     	else if (sortBy.equals("Unit"))
     			orderBy = " order by x.Device " + sortOrder + ", x.HouseCode " + sortOrder;
			else if (sortBy.equals("Action"))
     			orderBy = " order by x.Action " + sortOrder + ", x.HouseCode " + sortOrder + ", x.Device " + sortOrder;
    	else if (sortBy.equals("Description"))
     			orderBy = " order by z.Description " + sortOrder + ", x.Time " + sortOrder + ", x.HouseCode " + sortOrder + ", x.Device " + sortOrder;
			else if (sortBy.equals("Time"))
     			orderBy = " order by x.Time " + sortOrder + ", x.HouseCode " + sortOrder + ", x.Device " + sortOrder;
			else if (sortBy.equals("Category"))
     			orderBy = " order by x.Category " + sortOrder + ", x.Time " + sortOrder + ", x.HouseCode " + sortOrder + ", x.Device " + sortOrder;
    }
    
    if (orderBy != null)
      sql = sql + orderBy + ";";
    System.out.println(sql);
   
    return queryDatabase(sql);
   }
   
 
  public void setHouseCode(String houseCode) {
    this.houseCode = houseCode;
  }

  public String getHouseCode() {
    return this.houseCode;
  }

  public void setEventMonth(String month) {
    this.eventMonth = month;
  }

  public String getEventMonth() {
    return this.eventMonth;
  }

  public void setEventDay(String day) {
    this.eventDay = day;
  }

  public String getEventDay() {
    return this.eventDay;
  }

  public void setEventYear(String year) {
    this.eventYear = year;
  }

  public String getEventYear() {
    return this.eventYear;
  }

 
}